package vsp.uloha437;

import cz.zcu.fav.kiv.jsim.JSimSecurityException;
import cz.zcu.fav.kiv.jsim.JSimSystem;

/**
 * Krizovatka site.<br/>
 * <br/>
 * Se zadanou pravdepodobnosti preposila vstupni pozadavky do jedne z vystupnich
 * cest.
 *
 * @author Jiri Kucera (kalwi@students.zcu.cz)
 */
public class Fork implements Junction {
    private double presumption;
    private Junction out1;
    private Junction out2;

    /**
     * Konstruktor tridy.
     * @param out1 Prvni vystup krizovatky.
     * @param out2 Druhy vystup krizovatky.
     * @param presumption Pravdepodobnost, s kterou bude pozadavek poslan do
     * prvniho vystupu. Musi byt hodnota mezi 0 a 1.
     */
    public Fork(Junction out1, Junction out2, double presumption) {
	this.presumption = presumption;
	this.out1 = out1;
	this.out2 = out2;
    }

    @Override
    public void put(Transaction tr) throws JSimSecurityException {
	if (JSimSystem.uniform(0.0, 1.0) < presumption) {
	    out1.put(tr);
	} else {
	    out2.put(tr);
	}
    }

}
